; ADW verwalten, 3 Eingnge AN0, AN1, AN2

.equ	samp,1				; b1
.equ	done,0				; b0

.global ADWcon,ADWinit

ADWcon:
	mov		adwsta,w0
	bra		w0
	bra 	adwcon0
	bra 	adwcon1
	bra 	adwcon2
	bra		adwcon3
	bra		adwcon4
	bra		adwcon5
	bra		adwcon6
	
; Standby
adwcon0:
    return
    
; AN0 starten (L1)
adwcon1:
	clr		w0
	mov		w0,AD1CHS0		; AN0
	bset	AD1CON1,#samp	; Starten
	inc		adwsta
	return

; AN0 (L1) fertig?
adwcon2:
	btss	AD1CON1,#done
	return					; nicht fertig 
	mov		ADC1BUF0,w0
	cp		stromL1		; gemessener Wert hher?
	bra		gtu,adwcon2a	; nein
; Wert weiterreichen
	mov		w0,stromL1
; nchster: AN1 einschalten
adwcon2a:
	add		stromL1+6
	clr		w0
	addc	stromL1+8
	inc		stromL1+4
	mov		#1,w0
	mov		w0,AD1CHS0		; AN1
	inc		adwsta
	return
	
; AN1 (L2) Sanple und Wandlung starten
adwcon3:
	bset	AD1CON1,#samp	; Starten
	inc		adwsta
	return

; AN1 (L2) fertig?
adwcon4:
	btss	AD1CON1,#done
	return					; nicht fertig 
	mov		ADC1BUF0,w0
	cp		stromL2		; gemessener Wert hher?
	bra		gtu,adwcon4a	; nein
; Wert weiterreichen
	mov		w0,stromL2
; nchster: AN2 einschalten
adwcon4a:
	add		stromL2+6
	clr		w0
	addc	stromL2+8
	inc		stromL2+4
	mov		#2,w0
	mov		w0,AD1CHS0		; AN2
	inc		adwsta
	return

; AN2 (L3) Sanple und Wandlung starten
adwcon5:
	bset	AD1CON1,#samp	; Starten
	inc		adwsta
	return

    ; AN1 (L2) fertig?
adwcon6:
	btss	AD1CON1,#done
	return					; nicht fertig 
	mov		ADC1BUF0,w0
	cp		stromL3		; gemessener Wert hher?
	bra		gtu,adwcon6a	; nein
; Wert weiterreichen
	mov		w0,stromL3
; nchster: AN0 einschalten
adwcon6a:
	add		stromL3+6
	clr		w0
	addc	stromL3+8
	inc		stromL3+4
; Zyklus fertig?
	cp0		adwtimer
	bra		z,adwcon6b
	mov		#0,w0
	mov		w0,AD1CHS0		; AN0
	mov		#2,w0
	mov		w0,adwsta
	bset	AD1CON1,#samp	; Starten
	return
; Zyklus zu Ende
adwcon6b:
	clr		adwsta
	return

    





; --------------------- UPs --------------------	

; ADW Initialisierung fr einzelne Wandlungen
; Gewhlter Ablauf:
; Kanal whlen in ADCHS
; etwas warten
; Sample mit SAMP=1 starten, danach startet die Wandlung automatisch
; ende der Wandlung wenn DONE=1
; Wert aus ADCBUF0 holen
	
ADWinit:
	MOV		#0b111000,W0	; b2,b1,b0 = 0: Analogpin 
	MOV		W0,AD1PCFGL
	mov		#0x00e0,w0 	; interner Timer
	mov		w0,AD1CON1
	mov		#0,w0  		; CH1 = AN0
	mov		w0,AD1CHS0
	mov		#0,w0
	mov		w0,AD1CSSL
	mov		#0x1f03,w0	; Samplezeit=16x0,25=4us. Wandlungstakt=4x0,25=1us
	mov		w0,AD1CON3
	mov		#0x0000,w0
	mov		w0,AD1CON2
	bset	AD1CON1,#15
	return
	
	